/*
 * FTP/HTTP daemon
 * configargs.h Copyright (C) 1995, 96, 97 Alex Belits
 *
 * This source/code is public free; you can distribute it and/or modify
 * it under terms of the GNU General Public License (published by the
 * Free Software Foundation) either version two of this License, or any
 * later version.
 *
 */

#ifndef ARGS_H
#define ARGS_H 1

#include "lists.h"

class TypeArgs:public Item{
public:
int absolute;
char *pattern;
char *typeline;
char *dirprefix;
char *dirpostfix;
TypeArgs(char *pattern,char *typeline,char *dirprefix,char *dirpostfix,int abs=0
);
virtual ~TypeArgs(void);
};

class ConfigArgs:public Item{
public:
int paramc;
char **params;
int absolute;
ConfigArgs(int argc,char **args,int abs=0);
virtual ~ConfigArgs(void);
};

ConfigArgs *findargs(List *list,char *string);

#endif
