#ifndef MAXNAMLEN
#define MAXNAMLEN 1024
#endif

#ifdef SIGARGS
#undef SIGARGS
#endif
#define SIGARGS int sig

#ifdef SIGACTARGS
#undef SIGACTARGS
#endif
#define SIGACTARGS int sig

extern "C"{
int strcasecmp(const char*,const char*);
int strncasecmp(const char*,const char*,size_t);
void *mmap(void*,size_t,int,int,int,off_t);
int munmap(void*,size_t);
void bzero(void*,size_t);
int seteuid(uid_t);
int initgroups(const char*,gid_t);
int ftruncate(int,off_t);
int fchown(int,uid_t,gid_t);
int gethostname(char*,int);
}
